#include "array_mpi.h"
#include <stdlib.h>
#include <stdio.h>

/*
 * converts global coord to local coord
 */
int* getLocalCord(int xg, int yg, int zg){
        int *cr;
        cr = malloc(sizeof(int)*3);
        cr[0] = xg;
        cr[1] = yg;
        cr[2] = zg;
	cr[0] -= coords[0] * local_x;
	cr[1] -= coords[1] * local_y;
	cr[2] -= coords[2] * local_z;
        return cr;
}
/*
 * convert local coord to global coord
 */
int* getGlobalCord(int x, int y, int z){
        int *cr;
        cr = malloc(sizeof(int)*3);
        cr[0] = x+ local_x*coords[0];
        cr[1] = y+ local_y*coords[1];
        cr[2] = z+ local_z*coords[2];
        return cr;
        }
/*
 * gets the rank of the node that have input position
 */
int getDest(int x, int y, int z){
        int cr[3];
        int value;
        cr[0] = x/local_x;
        cr[1] = y/local_y;
        cr[2] = z/local_z;
        MPI_Cart_rank(gridcomm,cr,&value);
        return value;
}
/*
 * print the local float array to stdout
 */
void printLocalArray(float* array){
       int i,j,k;
        for(k=-1;k<=local_z;k++){
        printf("%d:array z = %d\n",cartrank,k);
                for(i=-1;i<=local_x;i++){
                        printf("%d: ",cartrank);
                        for(j=-1;j<=local_y;j++){
                                printf(" %8f ",array[GETLINDEX(i,j,k)]);
                        }
                        printf("\n");
                }
        printf("\n\n");
        }
}
/*
 * print a local integer array to stdout
 */
void printLocalIntArray(int* array){
        int i,j,k;
        for(k=-1;k<=local_z;k++){
        printf("%d:array z = %d\n",cartrank,k);
                for(i=-1;i<=local_x;i++){
                        printf("%d: ",cartrank);
                        for(j=-1;j<=local_y;j++){
                                printf(" %d ",array[GETLINDEX(i,j,k)]);
                        }
                        printf("\n");
                }
        printf("\n\n");
        }
}
/*
 * print the global array to stdout
 */
void printArray(float* array){
        int i,j,k;

        for(k=-1;k<=z;k++){
        printf("array z = %d\n",k);
                for(i=-1;i<=x;i++){
                        for(j=-1;j<=y;j++){
                                printf(" %8f ",array[GETINDEX(i,j,k)]);
                        }
                printf("\n");
                }
        printf("\n\n");
        }
}

