#include "heap.h"

/*
 * a struct to store all variables for a given fmm implementation
 */
typedef 
struct f {
	Heap* heap; // the heap
	float* timearray; // the timearray storing arrivaltimes
	int* bandarray; // storing band information
	float* velocityarray; // velocity field
	float* sentarray; // array containting values of sent points, used to avoid sending the same value multiple times
	int x,y,z,posx,posy,posz; // x,y,z is size of local fmm matrix, posx, posy, posz is global coords for the starting point
	} FmmData;

typedef
/*
 * Struct used for sending a border cell to another node. String its value and posistion with band information
 */
struct me {
        float value;
        int x;
        int y;
        int z;
	int n;
} MPI_Element;
/*
 * initilalize the FMM set velocity arrat, position of starting point and size of array
 */
FmmData* initFMM(float* velarray,int posx,int posy, int posz, int x, int y, int z);
/*
 * Free up used variables in FMM
 */
void freeFMM(FmmData* data);
/*
 * Execute the FMM
 */
void executeFMM(FmmData* data);
