//#include <gd.h>
#include "/opt/freeware/include/gd.h"
#include <stdio.h>
#include <stdlib.h>
#include "array_mpi.h"
#include <string.h>
#define MAXFLOAT ((float)3.40282347e+38)
#define DEBUG
/*
 * stores an array in a text file
 */

void printdatafile(float* array, int x, int y, int z){
	FILE* f;
	int i, j ,k;
	f = fopen("out.data", "w");
	if(!f){
		printf("Error opening file out.data ");
		return;
		}
		
	for(k=0;k<z;k++){
		for(j=0;j<y;j++){
			for(i=0;i<x;i++){
				fprintf(f,"%d.0 %d.0 %d.0 %lf \n",i,j,k,array[GETINDEX(i,j,k)]);
			}
			fprintf(f,"\n");
		}
	fprintf(f,"\n");
	}
	fclose(f);
} 
/*
 * Reads a binary float file into an array
 */
void readfile(float * array, char* file,int x, int y, int z){
	FILE* f;
	int read = 0;
	int i,j,k;
	f = fopen(file,"rb");
	printf("x = %d, y= %d, z=%d\n",x,y,z);
	fflush(stdout);
	bzero(array,sizeof(float)*x+2*y+2*z+2);
	printf("done zeroing array, starting read\n");
	fflush(stdout);
	for(i=0;i<x;i++)
		for(j=0;j<y;j++){
			read = fread(&array[GETINDEX(i,j,0)],sizeof(float),z,f);
			if(read != z){
				printf("Coudn't read hole file exiting, read %d\n",read);
				fclose(f);
				exit(1);
			}
	}
	printf("done read, closing file\n");
	fflush(stdout);
	fclose(f);
}

/*
 * Reads float array from a text file
 */
void readTextFile(float* array, char* file, int x, int y, int z){
	FILE *f;
	float temp;
	char ctemp = 'h';
	int i,j,t;
	f = fopen(file,"r");
	if(!f){
		printf("Error opening file %s ",file);
		return;
	}
	bzero(array,sizeof(float)*ARRAYSIZE);
	memset(array,1,sizeof(float)*ARRAYSIZE);
	fread(&ctemp,sizeof(char),1,f);
	for(i=0;i<2;i++){
		while(ctemp != '\n'){	
			printf(".");	
			fread(&ctemp,sizeof(char),1,f);
		}
		printf("\n");
	}
//	for(t=0;t<y*x;t++){
	t=0;
	while(fscanf(f,"%d %d %f\n",&i,&j,&temp) != EOF){
	array[GETINDEX(i-1,j-1,z)] = temp;
	t++;
	}
	printf("read %d values\n",t);
	fclose(f);
}

/*
 * saves a float array as a png image
 */
void printFloatImage(float* array, char* file, int sizex, int sizey, int z){
  /* Declare the image */
  gdImagePtr im;
  /* Declare output files */
  FILE *pngout;
  #ifdef DEBUG
  printf("printing image to file \n");
  #endif
  int maxt, mint;
  float max = 0,min = MAXFLOAT;
  int i,j,r,g,b,t;
    for(i=0;i<sizex;i++){
            for(j=0;j<sizey;j++){
		if(array[GETINDEX(i,j,z)] < min && array[GETINDEX(i,j,z)] != BIGFLOAT){
			min = array[GETINDEX(i,j,z)];
			printf("new min value at %d %d %d value is %f\n",i,j,z,min);
		} else if(array[GETINDEX(i,j,z)] > max&& array[GETINDEX(i,j,z)] != BIGFLOAT){
			max = array[GETINDEX(i,j,z)];
		}
   	}
  }

  for(i=0;i<sizex;i++){
            for(j=0;j<sizey;j++){
	    	if(array[GETINDEX(i,j,z)] == BIGFLOAT|| array[GETINDEX(i,j,z)] == BIGFLOAT*2){
			array[GETINDEX(i,j,z)] = max;
		}
   	}
  }
  #ifdef DEBUG
  printf("Maxvalue is %f, min value is %f\n",max,min);
  #endif
  /* Allocate the image: 64 pixels across by 64 pixels tall */
  im = gdImageCreate(sizex, sizey);

  /* Allocate the color black (red, green and blue all minimum).
    Since this is the first color in a new image, it will
    be the background color. */
    maxt = 0;
    mint = 9999999;
  for(i=0;i<sizex;i++){
	for(j=0;j<sizey;j++){
	//printf("color is %d\n",(int) (((float)array[GETINDEX(i,j,z)] / (float)(max-min)) *255));
	
	t = (int) ((((float)array[GETINDEX(i,j,z)]-min) / (float)(max-min)) *(255*4));
	if(maxt < t)
		maxt = t;
	if(mint > t)
		mint = t;
	//printf("%d\n",t);
	/* red- yellow -green - cyan - blue*/
	/*if(t<255){
		r= 255;
		g= t;
		b=0;
	} else if(t<255*2){
		r= 255*2 -t;
		g = 255;
		b = 0;
	} else if(t<255*3){
		r = 0;
		g = 255;
		b = t - 255*2;
	} else{
		r = 0;
		g = 255*4 - t;
		b = 255;
	}*//* blue - cyan - green - yeallow - red*/
	t = 255*4 -t;
	if(t<255){
		r= 255;
		g= t;
		b=0;
	} else if(t<255*2){
		r= 255*2 -t;
		g = 255;
		b = 0;
	} else if(t<255*3){
		r = 0;
		g = 255;
		b = t - 255*2;
	} else{
		r = 0;
		g = 255*4 - t;
		b = 255;
	}
    gdImageSetPixel(im, i, j, gdImageColorResolve(im, r/*red*/,g/*green*/, b/*blue*/ ));
    }
  }
  #ifdef DEBUG
  printf("Maxvalue is %d, min value is %d\n",maxt,mint);
  #endif

  /* Open a file for writing. "wb" means "write binary", important
    under MSDOS, harmless under Unix. */
  pngout = fopen(file, "wb");

  /* Output the image to the disk file in PNG format. */
  gdImagePng(im, pngout);

  /* Close the files. */
  fclose(pngout);

  /* Destroy the image in memory. */
  gdImageDestroy(im);	
}
