#ifndef __HEAP_H
#define __HEAP_H
typedef
/*
 * a element in the heap
 */
struct e {
        float value;
        int x;
        int y;
        int z;
} Element;

/*
 * heap storage struct
 */
typedef struct h {
	Element** array;
	int maxsize;
	int heapsize;
} Heap;
/*
 * Initialize the heap to a specific max size.
 * The heap should not exceed the size, it will then fail
 */
Heap* initHeap(int size);
/*
 * Return and remove the smallest element in the heap
 */
Element* heapExtractMin(Heap* heap);
/*
 * Returns the smallest element in the heap without removing it
 */
Element* heapGetMin(Heap* heap);
/*
 * Insert a new element to the heap
 */
void heapInsert(Heap* heap,Element* key);
#endif
